// dfunc.  functions of n variables f(*x)
// by Sergei Khashin 2017-06-10


class MathFunc 
{
private:
	MathFunc1 *fv;
	char *prot;					//   NULL,    
public:
	MathFunc() { prot = NULL;};	// 

	//virtual double operator () (double*) = 0;
	virtual double operator () (dvect &) = 0;
	virtual int N() = 0;
	// g :=     v, eps -  
	void gradient(dvect &v, dvect &g, double eps);
	int counter;	//        1.
	void setProt(char *prot_);

	//----------------------------------------------------------------------------
	//  
	// v        -    ,     
	// min, max -      
	// epsX     -     
	// epsF     -     
	//
	//   
	double minGrad(dvect &v, dvect &min, dvect &max, double epsX, double epsF);
	//   
	double minCoord(dvect &v, dvect &min, dvect &max, double epsX, double epsF);
	double minCoor2(dvect &v, dvect &min, dvect &max, double epsX, double epsF); //    N<=6
};


//-----------------------------------------------------------------------------
// ,  min[i] <= v[i] <= max[i]
//   alpha , 
// ,  min[i] <= v[i] + alpha*g[i] <= max[i]
double maxAlpha(dvect &v, dvect &min, dvect &max, dvect &g);
